﻿using FluentPolicyAuth.Data;
using FluentPolicyAuth.Models.Entities;
using FluentPolicyAuth.Models.ViewModels;
using Microsoft.EntityFrameworkCore;
using static FluentPolicyAuth.Responses.CustomResponses;

namespace FluentPolicyAuth.Services
{
    public class UserService : IUserService
    {
        private AppDbContext _appDbContext;

        public UserService(AppDbContext appDbContext)
        {
            _appDbContext = appDbContext;
        }

        public async Task<LoginResponse> LoginAsync(LoginViewModel model)
        {
            if (string.IsNullOrWhiteSpace(model.UserName) || string.IsNullOrWhiteSpace(model.Password))
                return new LoginResponse(false, "Invalid account information");

            var user = _appDbContext.Users.Where(u => u.Name == model.UserName).FirstOrDefault();
            if (user is null || user.Password != model.Password)
                return new LoginResponse(false, "Invalid account information");

            var policies = await _appDbContext.UserPolicies.Where(p => p.UserId == user.Id && p.IsEnable).ToListAsync();

            return new LoginResponse(true, "Success", user, policies);
        }

        public Task<RegistrationResponse> RegisterAsync(RegisterViewModel model)
        {
            throw new NotImplementedException();
        }
    }
}
